#include <stdio.h>

int main()
{
    unsigned long int N,K,i,j,k,terulet=0,dbs=0;
    int f=0;
    scanf("%lu %lu",&N,&K);
    
    unsigned long int mini=N+1,minj=N+1,maxi=0,maxj=0;
    
    unsigned long int M[N][N];
    
    for(i=0;i<N;i++){
        for(j=0;j<N;j++){
            scanf("%lu",&M[i][j]);
        }
        
    }
    
    for(k=1;k<=K;k++){
        dbs=0;
        mini=N+1;
        minj=N+1;
        maxi=0;
        maxj=0;
        f=0;
        for(i=0;i<N;i++){
            for(j=0;j<N;j++){
                if(M[i][j]==k){
                    dbs=dbs+1;
                    if(i<=mini){
                        mini=i;}
                    if(i>=maxi){
                        maxi=i;}
                    if(j<=minj){
                        minj=j;}
                    if(j>=maxj){
                        maxj=j;}
                }
                
            }
            
            
        }
     
      if(dbs==1){
          terulet++;
          
      }
      if(dbs>1){
        for(i=mini;i<=maxi;i++){
            for(j=minj;j<=maxj;j++){
                if(M[i][j]!=k){
                    f=1;
                    
                    break;
                }
            }
        }  
          
        if(f==0){
            terulet++;
        }  
          
      }
      
        
    }
    
    
    
    
    printf("%lu",terulet);
    
    

    return 0;
}